/*
  QuidoStackDll - Mapovn funkc z knihovny QuidoStackDll.dll
  Vytvoeno pro Visual C++

  Vydavatel :  Papouch s.r.o. - http://www.papouch.com/
  Autor     :  Martin Zmenk zamecnik@papouch.com

  Poznmky  : k pouit funkc jsou poteba knihovny QuidoStackDll.dll a CommIntfDll.dll, q_QuidoDllMap.cpp
              v ppad pouit pro USB jsou poteba t nainstalovan ovladae FTD direct drivers a knihova FTD2XX.dll
  Upozornn: veker parametry Index, a to i v ppad vstup a vstup quida, jsou slovny od 0 !!!
*/
//---------------------------------------------------------------------------

#ifndef q_QuidoDllMapH
#define q_QuidoDllMapH

extern const char * QDLLName;// = "QuidoStackDll.dll";
      //-- identifikace udlost (event) vyvolanch Quidem. pro zasln udlost registrujet jejich pjem pomoc qRegisterMsgNotifications nebo qRegisterCallBackNotifications
const int qev_Base = 0x1FF;
const int qev_InputsChange = qev_Base + 1; //zmna vstup - obecn oznm, z byla zaznamenna zmna nkterho vstupu
const int qev_OutputsChange = qev_Base + 2; //zmna vstup - oznm, e byl znnn nkter vstup
const int qev_InputChange = qev_Base + 3; //zmna vstupu - oznm, e byl zmnn jednotliv vstup (oznamuje kad vstup zvl᚝)
const int qev_OutputChange = qev_Base + 4; //zmna vstupu - oznm, e byla zaznamenna zmna jednotlivho vstupu
const int qev_CIOpen = qev_Base + 5; //-- oteven komunikanho kanlu quida
const int qev_CIClose = qev_Base + 6; //-- uzaven komunikanho kanlu quida

typedef unsigned int QHandle;
typedef unsigned short word;
typedef int longbool; //32bit boolean value;  0 = false, 1 (nebo jin hodnota ne 0) = true
typedef int reStat; //-- typ pro nvratovou hodnotu funkc; 0 = funkce probhla v podku, jinak chybov kd <> 0
typedef char * pChar;
typedef unsigned int hwnd;
typedef void (_stdcall * QHandleNotificationEvent)(QHandle Handle, word Event,word Param,unsigned int CallBackID); //-- typ callbackov procedure pro oznamovn udlost (lze pout t oznamovn pes windows zprvy)
//--- Dynamicky mapovan funkce z DLL knihovny

extern pChar (_stdcall *DllInfo)();// QDLLName; //-- vrac informan text o knihovn

extern int (_stdcall *qHandlesCount)(); //-- vrac poet vytvoench Quid (funkcemi qCreateQuido...); -1 = chyba
extern QHandle (_stdcall *qHandleByIndex)(int index); //-- vrac handle na Quido podle indexu (0..qHandlesCount-1); 0 = neplatn handle
extern int (_stdcall *ciHandlesCount)(); //-- vrac poet vytvoench komunikanch rozhran (a ji spolen s Quidem nebo zvl᚝ v CommIntfDll.dll); -1=chyba
extern QHandle (_stdcall *ciHandleByIndex)(int Index); //-- vrac handle na komunikan rozhran podle indexu (0..ciHandlesCount-1); 0=chyba

extern QHandle (_stdcall *qCreateQuido)(pChar connectionstring,pChar deviceString);
    //-- vytvoi objekt Quida. vrac handle vytvoenho objektu Quida; 0 = nepovedlo se vytvoit
    //--       connection string je etzec pro vytvoen komunikanho rozhrann, uruje komunikan kanl a jeho nastaven (sriov port, tcp, udp, nebo ftd_usb)
    //--       devicestring specifikuje parametry zazen Quido (adresu. v ppad e je na komunikanm kanlu pouze jedno zazen, lze zadat univerzln adresu $FE)
    //   Tvorba connectionstringu : jsou to hodnoty ve tvaru "parametr=hodnota" oddleny stednkem. uruj typ pipojen
    //          nejdleitjm parametrem je "provider", uruje typ komunikanho kanlu. me to bt SERIAL_PORT, TCP_CLIENT, UDP_CLIENT nebo FTD_USB
    //          kad kanl pak me mt dal parametry. SERIAL_PORT (comport=slo portu;baudrate=rychlost - nemus bt zadno), TCP_CLIENT(host=ip adresa zazen;port=tcp port zazen), UDP_CLIENT(stejn jako TCP), FTD_USB(index=poadov slo zazen; nebo device=st nzvu zazen; nebo serial_number=sriov slo zazen; nebo vid=vid;pid=pid; nebo nemus mt dn parametr, vezme se prvn pipojen zazen typu FTD_USB
    //          pklady: "provider=SERIAL_PORT;comport=1", "provider=TCP_CLIENT;host=192.168.1.254;port=10001", "provider=UDP_CLIENT;host=192.168.1.254;port=10001", "provider=FTD_USB;device=Quido"
    //   Tvorba devicestringu: p. "addr=12", "addr=$FE" ($ - znamen slo je zadno v hexa, $FE=univerzln adresa)

extern QHandle (_stdcall *qCreateQuidoCI)(QHandle ciHandle,pChar devicestring); //-- Vytvo objekt Quida, pouije se komunikan rozhrann ji explicitn vytvoen v CommIntfDll (ciHandle)
extern QHandle (_stdcall *qCreateQuidoEx)(pChar connectionstring,pChar deviceString, unsigned int ciEventType); //-- umouje specifikovat zpsob voln udlost mezi komunikanm rozhrannm a objektem quida  - ciEventType (0 - sendmessage, 1 - callback, 2 - postmessage). nedoporuuje se pouvat, pokud k tomu nen dvod
extern QHandle (_stdcall *qCreateQuidoCIEx)(QHandle ciHandle,pChar devicestring,unsigned int ciEventType); //-- pouit explicitn vytvoenho komunikanho rozhrann, specifikace zpsobu voln udlost

extern QHandle (_stdcall *qGetQuidoCIHandle)(QHandle qHandle);  //-- vrt handle komunikanho rozhran pipojenmu ke Quidu

extern reStat (_stdcall *qOpen)(QHandle qHandle); //-- oteve komunikan kanl Quida (oteve port, nave tcp spojen, ... podle typu komunikanho rozhran; nutno pro komunikaci se zazenm; vrt 0 pokud OK, chybov kd v opanm ppad (plat obecn pro nvratov typ reStat (integer))
extern reStat (_stdcall *qClose)(QHandle qHandle); //-- zave komunikan kanl Quida; vrt 0 pokud OK, chybov kd v opanm ppad
extern reStat (_stdcall *qIsOpened)(QHandle qHandle,longbool & Opened); //-- zjist, zda je komunikan kanl quida oteven
extern reStat (_stdcall *qReleaseQuido)(QHandle qHandle); //-- zru objekt quida (vetn pslunho komunikanho rozhran - pokud nen zadno pi vytvoen explicitn pomoc handlu - qCreateQuidoCI)

extern int (_stdcall *qInputsCount)(QHandle qHandle); //-- vrt poet vstup Quida; -1=chyba
extern int (_stdcall *qOutputsCount)(QHandle qHandle); //-- vrt poet vstup Quida; -1=chyba
extern int (_stdcall *qInputCountersCount)(QHandle qHandle); //-- vrt poet ta vstup; -1=chyba; standardn poet ta vstup=poet vstup, maximln vak 60

extern reStat (_stdcall *qInputStateByIndex)(QHandle qHandle,int Index,longbool & State);//-- vrt do State stav vstupu podle indexu (0..poet vstup-1) (true=je na vstupu napt, false=neni); nvratov hodnota: 0-ok, jinak chyba
extern reStat (_stdcall *qOutputStateByIndex)(QHandle qHandle,int Index,longbool & State);//-- vrt do State stav vstupu podle indexu (0..poet vstup-1)  (true=je na vstupu napt, false=neni); nvratov hodnota: 0-ok, jinak chyba
extern reStat (_stdcall *qInputCounterValueByIndex)(QHandle qHandle,int Index,unsigned int & Value,longbool NullCounter); //-- vrt do Value hodnotu tae vstupu podle indexu (0..poet ta-1); pokud je NullCounter true, ta se zhy vynuluje

extern reStat (_stdcall *qGetInputs)(QHandle qHandle,bool * Inputs, int & Len); //-- vrt v poli stav vech vstup. do inputs je teba zadat ukazatel na pole alokovan na (poet vstup) byt; do Len je teba zadat velikost tohoto pole; pi pouit klasickho pole v delphi (array of boolean) je teba zadat ukazatel na prvn prvek pole (@pole[0]);
             //---  pokud je ve v podku, od Inputs se vypln stavy vstup, do Len se vypln aktuln velikost pole a nvratov hodnota je 0
             //---  pokud se do Inputs zad nil, do Len se vypln potebn velikost pole a nvratov hodnota je 0
             //---  pokud se vyskytne chyba (stav vstup nelze zjistit, nebo zadan velikost Len je nedostaten), nvratov hodnota je chybov kd <> 0
extern reStat (_stdcall *qGetOutputs)(QHandle qHandle,bool * Outputs,int & Len);//-- vrt v poli stav vech vstup. princip jako u qGetInputs

extern reStat (_stdcall *qSetOutput) (QHandle qHandle,int Index, longbool State);//-- Nastav stav vstupu Quida podle indexu (State:true=sepnout,false=rozepnout). pokud je nvratov hodnota 0=OK, jinach chyba
extern reStat (_stdcall *qSetOutputTimered)(QHandle qHandle,int Index,bool State,int Time);//-- Nastav stav vstupu na urit as (Time=as ve vteinch).pokud je nvratov hodnota 0=OK, jinach chyba

extern reStat (_stdcall *qSetOutputs)(QHandle qhandle,bool * Outputs, int Len);//-- Nastav najednou stav vech vstup. do outputs se zad pole boolen (1 bytovch). Len uruje velikost pole; pokud je nvratov hodnota 0=OK, jinach chyba

extern reStat (_stdcall *qGetRecentInputsState)(QHandle qHandle, bool * Inputs,int & Len); //-- vrt v poli naposledy znm stav vstup - stejn jako qGetInputs, akort se nedotazuje pmo zazen, ale vrac naposledy zjitn stav. vhodn nap. po udlosti qev_InputsChange.
extern reStat (_stdcall *qGetRecentOutputsState)(QHandle qHandle,bool * Outputs, int & Len); //-- vrt v poli naposledy znm stav vstup - procuje jako qGetRecentInputsState

extern reStat (_stdcall *qGetRecentInputByIndex)(QHandle qHandle,int Index,longbool & State); //-- vrt naposledy znm stav vstupu Quida podle Indexu (jako qGetInputStateByIndex, akort se nedotazuje pmo zazen, ale vrac naposledy zjitn stav
extern reStat (_stdcall *qGetRecentOutputByIndex)(QHandle qHandle,int Index,longbool & State);//-- vrt naposledy znm stav vstupu Quida podle Indexu. pracuje jako qGetRecentInputByIndex
extern reStat (_stdcall *qGetRecentInputCounterByIndex)(QHandle qHandle,int Index,int & Value); //-- vrt naposledy znm stav tae vstupu Quida podle Indexu.
extern reStat (_stdcall *qGetRecentCounterSettingByIndex)(QHandle qHandle,int Index,longbool & Rising,longbool & Falling); //-- vrt naposledy znm stav nastaven vstupu Quida podle Indexu

extern reStat (_stdcall *qRefreshRecentStates)(QHandle qHandle,longbool Inputs,longbool Outputs,longbool Counters,longbool CounterSettings);

extern reStat (_stdcall *qGetAutoNotify )(QHandle qHandle, longbool & Value); //-- vrt do Value zda je aktivovno automatick oznamovn zmny stavu vstup (pokud je registrovno oznamovn pomoc qRegisterMsgNotifications nebo qRegisterCallBackNotifications;
extern reStat (_stdcall *qSetAutoNotify)(QHandle qHandle, longbool Value); //-- nastav nebo zru automatick oznamovn zmny stavu vstup (true=nastavit, false=zruit)

extern reStat (_stdcall *qSetCounterSetting ) (QHandle qHandle, int Index,longbool Rising,longbool Falling); //-- Nastaven tae (na kter hrany signlu se inkrementuje - rising=nbn, falling=sestupn)
extern reStat (_stdcall *qGetCounterSetting)(QHandle qHandle,int Index,longbool & Rising,longbool & Falling); //-- Zjitn nastaven tae

extern reStat (_stdcall *qRegisterMsgNotifications)(QHandle Handle,hwnd WHandle,unsigned int Msg,longbool blocking); //-- registruje zasln udlost Quida pomoc Windows zprv (Oteven a zaven komunikanho kanlu, zmny stav vstup, ...). zadv se hWnd okna, kter zprvu pijm a identifikaci zprvy, kter je zaslna. v parametru zprvy WParam je zasln handle Quida, kter ji zasl, v LParamLo je zasln typ udlosti, LParamHi ppadn dodaten parametr
extern reStat (_stdcall *qUnregisterMsgNotifications)(QHandle Handle);  //-- ru zasln udlost Quida pomoc Windows zprv
extern reStat (_stdcall *qRegisterCallBackNotifications)(QHandle Handle, QHandleNotificationEvent CallBackEntryPoint, unsigned int CallBackID); //-- registruje zasln udlost Quida pomoc voln callbackov funkce formtu QHandleNotificationEvent
extern reStat (_stdcall *qUnregisterCallBackNotifications )(QHandle Handle);//-- ru zasln udlost Quida pomoc callbackov funkce

extern reStat (_stdcall *qInfo) (QHandle qHandle,pChar Info,int & Len); //-- vrac textovou identifikaci zazen (Quida)
extern reStat (_stdcall *qReset)(QHandle qHandle); //-- Resetovn zazen
extern reStat (_stdcall *qGetAddress)(QHandle qHandle,int & Addr); //-- zjitn adresy zazen
extern reStat (_stdcall *qSetAddress)(QHandle qHandle, int & Addr); //-- nastaven adresy zazen (0-253)
extern reStat (_stdcall *qGetUserData)(QHandle qHandle,pChar UserData, int & Len); //-- zskn uvatelskch dat (16 byt)
extern reStat (_stdcall *qSetUserData) (QHandle qHandle,pChar UserData,int Len); //-- nastaven uivatelskch dat (16 byt)
extern reStat (_stdcall *qGetFactoryInfo)(QHandle qHandle,int & ProductID,int & SerialNumber,unsigned int & FactoryData); //-- zjskn vrobnch dat (sriovho sla,..) zazen


extern reStat (_stdcall *ciGetConnectionStringDlg)(pChar OutConnStr, int & Len,longbool & OKReturn,pChar DefaultValue,pChar Caption); //-- Vyvol dialogov okno pro vytvoen pipojovacho etzce (connection string). Vrac hodnotu<>0, pokud nastala chyba
                        //-- OutConStr:sem je vrcen connectionstring, Len:velikost bufferu OutConStr, OKReturn:vrceno true, pokut bylo stisknuto OK, DefaultValue:ppadn pednastaven vchozho connectionstringu, Caption: vlastn titulek dialogu

extern reStat (_stdcall *qSndRcvSpin97)(QHandle qHandle,unsigned char Inst,void * Data,int DataLen,
                  unsigned char & RcvAck,void * RcvData,int & RcvDataLen, int MaxTimeOut);
                  //-- Zale spinel paket, zadan instrukc Inst a daty Data (velikosti DataLen) a ek na odpov (maximln MaxTimeOut milisekund)
                  // Pokud pijde odpov, nvratov hodnota je 0, do bufferu RcvData o velikosti RcvDataLen se zapou vrcen data spinel paketu a v RcvDataLen se vrt aktuln velikost dat.
                  // RcvAck vrt kd odpovdi (0 = OK)
                  // Pokud se paket neodele, nebo se nevrt odpov, nebo vznikne jin chyba, nvratov hodnota <> 0

extern reStat (_stdcall *LastError)(); //-- vrt chybov kd naposledy volan funkce. 0=funkce probhla v podku
extern reStat (_stdcall *LastErrorText)(pChar Text,int & Size); //-- vrt text chyby naposledy volan funkce

//-- funkce pro detekci spnosti zaveden knihovny
bool QDllOK(); //-- vrac true, pokud byla knihovna a vechny jej funkce v podku zavedeny
               //   pi prvnm voln inicializuje knihovnu
               //   je poteba tuho funkci zavolat ped prvnm pouitm jakkoliv funkce, nejlpe pi inicializaci aplikace !!!!

pChar QDllInitMsg(); //-- vrac text chyby, pokud nebyla knihovna v podku zavedena
void QDTestInit(); //-- nedl nic, pokud byla knihovna v podku zavedena, jinak vyvol vyjmku s textem chyby

//---------------------------------------------------------------------------
#endif
